commit 1d8cd5cdd36efea5e0134a40e42632b95c5ccb42
Author: Moritz Bunkus <m.bunkus@linet.de>
Date:   Mon Jan 30 17:13:03 2017 +0100

    ActionBar: Verwendung bei UStVa-Konfiguration

diff --git a/bin/mozilla/ustva.pl b/bin/mozilla/ustva.pl
index 94ea3d831..eb5fa14bb 100644
--- a/bin/mozilla/ustva.pl
+++ b/bin/mozilla/ustva.pl
@@ -774,6 +774,8 @@ $::form->{title} = $::locale->text('Tax Office Preferences');
 
   # edit all taxauthority prefs
 
+  setup_ustva_config_step1_action_bar();
+
   $::form->header;
 
   my $ustva = USTVA->new();
@@ -800,8 +802,6 @@ $::form->{title} = $::locale->text('Tax Office Preferences');
 
   my %_hidden_local_variables = (
     'saved'       => $::locale->text('Check Details'),
-    'nextsub'     => 'config_step2',
-    'warnung'     => '0',
   );
 
   foreach my $variable (keys %_hidden_local_variables) {
@@ -845,6 +845,8 @@ sub config_step2 {
 
   $::auth->assert('advance_turnover_tax_return');
 
+  setup_ustva_config_step2_action_bar();
+
   $form->header();
 
   my $fa_land_nr         = '';
@@ -923,7 +925,6 @@ sub config_step2 {
   my %_hidden_local_variables = (
       'fa_land_nr'          => $fa_land_nr,
       'fa_bufa_nr'          => $fa_bufa_nr,
-      'warnung'             => 0,
       'taxnumber'           => $stnr,
       'lastsub'             => 'config_step1',
       'nextsub'             => 'save',
@@ -941,7 +942,7 @@ sub config_step2 {
     fa_voranmeld fa_dauerfrist
     accounting_method
     type
-    saved                   callback
+    saved
   );
 
   foreach my $variable (@_hidden_form_variables) {
@@ -952,7 +953,6 @@ sub config_step2 {
   my $template_ref = {
      input_steuernummer              => $input_steuernummer,
      readonly                        => '', #q|disabled="disabled"|,
-     callback                        => $form->{callback},
      COA_Germany                     => $form->{COA_Germany},
      hidden_variables                => $_hidden_variables_ref,
   };
@@ -1065,3 +1065,31 @@ sub setup_ustva_report_action_bar {
     );
   }
 }
+
+sub setup_ustva_config_step1_action_bar {
+  for my $bar ($::request->layout->get('actionbar')) {
+    $bar->add(
+      action => [
+        t8('Continue'),
+        submit    => [ '#form', { action => 'config_step2' } ],
+        accesskey => 'enter',
+      ],
+    );
+  }
+}
+
+sub setup_ustva_config_step2_action_bar {
+  for my $bar ($::request->layout->get('actionbar')) {
+    $bar->add(
+      action => [
+        t8('Save'),
+        submit    => [ '#form', { action => 'save' } ],
+        accesskey => 'enter',
+      ],
+      action => [
+        t8('Back'),
+        call => [ 'kivi.history_back' ],
+      ],
+    );
+  }
+}
diff --git a/locale/de/all b/locale/de/all
index e3496a3a2..2d30717ce 100755
--- a/locale/de/all
+++ b/locale/de/all
@@ -3432,7 +3432,6 @@ $self->{texts} = {
   'Used for Purchase'           => 'im Einkauf verwenden',
   'Used for Sale'               => 'im Verkauf verwenden',
   'User'                        => 'Benutzer',
-  'User Config'                 => 'Einstellungen',
   'User Preferences'            => 'Benutzereinstellungen',
   'User access'                 => 'Benutzerzugriff',
   'User list'                   => 'Benutzerliste',
@@ -3638,14 +3637,12 @@ $self->{texts} = {
   'config/kivitendo.conf: Missing parameters in "authentication/ldap". Required parameters are "host", "attribute" and "base_dn".' => 'config/kivitendo.conf: Fehlende Parameter in "authentication/ldap". Benötigt werden "host", "attribute" und "base_dn".',
   'consumed'                    => 'Im Zeitraum',
   'contact_list'                => 'ansprechperson_liste',
-  'continue'                    => 'weiter',
   'correction'                  => 'Korrektur',
   'correction_br'               => 'Korr.',
   'cp_greeting to cp_gender migration' => 'Datenumwandlung von Titel nach Geschlecht (cp_greeting to cp_gender)',
   'customer'                    => 'Kunde',
   'customer_list'               => 'kundenliste',
   'dated'                       => 'datiert',
-  'debug'                       => 'Debug',
   'delete'                      => 'Löschen',
   'delete item'                 => 'Position löschen',
   'deleted'                     => 'gelöscht',
diff --git a/templates/webpages/ustva/config_step1.html b/templates/webpages/ustva/config_step1.html
index 485098ee3..6afb008b9 100644
--- a/templates/webpages/ustva/config_step1.html
+++ b/templates/webpages/ustva/config_step1.html
@@ -2,7 +2,7 @@
 [% USE HTML %]
 <h1>[% 'Tax Office Preferences' | $T8 %]</h1>
 
-<form name="verzeichnis" method="post" action="[% HTML.escape(script) %]">
+<form name="verzeichnis" method="post" action="[% HTML.escape(script) %]" id="form">
 <table width="100%">
     <tr>
      <td>
@@ -86,14 +86,6 @@
            </table>
 
            </fieldset>
-
-           <br>
-           <br>
-           <hr>
-           <!--<input type=submit class=submit name=action value="
-           [% 'debug' | $T8 %]">-->
-           <input type=submit class=submit name=action
-             value="[% 'continue' | $T8 %]">
          </td>
        </tr>
      </table>
diff --git a/templates/webpages/ustva/config_step2.html b/templates/webpages/ustva/config_step2.html
index a8a59c6cb..8325c507d 100644
--- a/templates/webpages/ustva/config_step2.html
+++ b/templates/webpages/ustva/config_step2.html
@@ -2,7 +2,7 @@
 [% USE HTML %]
 <h1>[% 'Tax Office Preferences' | $T8 %]</h1>
 
-  <form name="elsterform" method="post" action="[% script %]">
+  <form name="elsterform" method="post" action="[% script %]" id="form">
     <table width="100%">
        <tr>
          <td colspan=2>
@@ -174,37 +174,6 @@
            <hr>
          </td>
        </tr>
-       <tr>
-         <td align="left">
-
-          [%- IF callback %]
-           <input type="button" name="Verweis" value="[% 'User Config' | $T8 %]"
-            onClick="self.location.href='[% callback %]">
-          [%- ELSE %]
-            <input type="submit" class="submit" name="action" value="[% 'back' | $T8 %]">
-          [%- END %]
-
-          [%- IF warnung %]
-
-            <input type="hidden" name="nextsub" value="config_step2">
-            <input type="submit" class="submit" name="action"
-              value="[% 'continue' | $T8 %]">
-
-            <input type="hidden" name="saved" value="[% 'Check
-              Details' | $T8 %]">
-
-          [%- ELSE %]
-
-            <input type="hidden" name="nextsub" value="save">
-            <input type="submit" class="submit" name="action" value="[% 'Save' | $T8 %]">
-
-          [%- END %]
-
-         </td>
-         <td align="right">
-           <H2 class="confirm">[%- saved %]</H2>
-         </td>
-      </tr>
   </table>
 
 [%- FOREACH var = hidden_variables %]