commit 36ca259b22d6db98fc7a1bedef95d5f0e618c444
Author: Bernd Bleßmann <bernd@kivitendo-premium.de>
Date:   Fri Jan 25 13:33:11 2019 +0100

    DisplayableNamePrefs: Überstzungen

diff --git a/locale/de/all b/locale/de/all
index 4d64c46d2..9bfd60f9c 100755
--- a/locale/de/all
+++ b/locale/de/all
@@ -1014,6 +1014,7 @@ $self->{texts} = {
   'Display'                     => 'Anzeigen',
   'Display file'                => 'Datei anzeigen',
   'Display options'             => 'Anzeigeoptionen',
+  'Displayable Name Preferences' => 'Einstellungen für Anzeigenamen',
   'Do not change the tax rate of taxkey 0.' => 'Ändern Sie nicht den Steuersatz vom Steuerschlüssel 0.',
   'Do not check for duplicates' => 'Nicht nach Dubletten suchen',
   'Do not link to a project.'   => 'Nicht mit einem Projekt verknüpfen.',
@@ -1112,6 +1113,7 @@ $self->{texts} = {
   'E-Mail-Journal'              => 'E-Mail-Journal',
   'E-mail'                      => 'E-Mail',
   'E-mail address missing!'     => 'E-Mail-Adresse fehlt!',
+  'E.g. "<%customernumber%> <%name%>"' => 'Beispiel: "<%customernumber%> <%name%>"',
   'EAN'                         => 'EAN',
   'EAN-Code'                    => 'EAN-Code',
   'EB-Wert'                     => 'EB-Wert',
@@ -2133,6 +2135,7 @@ $self->{texts} = {
   'Open this Website'           => 'Homepage in neuem Fenster öffnen',
   'OpenDocument/OASIS'          => 'OpenDocument/OASIS',
   'Openings'                    => 'Öffnungszeiten',
+  'Option'                      => 'Option',
   'Optional comment'            => 'Optionaler Kommentar',
   'Options'                     => 'Optionen',
   'Or download the whole Installation Documentation as PDF (350kB) for off-line study (currently in German Language): ' => 'Oder laden Sie die komplette Installationsbeschreibung als PDF (350kB) herunter: ',
@@ -3231,6 +3234,7 @@ $self->{texts} = {
   'The discount must be less than 100%.' => 'Der Rabatt muss kleiner als 100% sein.',
   'The discount must not be negative.' => 'Der Rabatt darf nicht negativ sein.',
   'The discounted amount will be shown in documents.' => 'Der Rabattbetrag wird in Belegen ausgewiesen.',
+  'The display of (mainly) picker results can be configured. To insert the value of one option use <%Name%>.' => 'Die Anzeigenamen von (hauptsächlich) Auswahl-Ergebnissen (Picker) können konfiguriert werden. Um einen Wert einer Option in die Anzeige aufzunehmen, verwenden Sie <%Name%>.',
   'The document has been changed by another user. No mail was sent. Please reopen it in another window and copy the changes to the new window' => 'Die Daten wurden bereits von einem anderen Benutzer verändert. Deshalb ist das Dokument ungültig und es wurde keine E-Mail verschickt. Bitte öffnen Sie das Dokument erneut in einem extra Fenster und übertragen Sie die Daten',
   'The document has been changed by another user. Please reopen it in another window and copy the changes to the new window' => 'Die Daten wurden bereits von einem anderen Benutzer verändert. Deshalb ist das Dokument ungültig. Bitte öffnen Sie das Dokument erneut in einem extra Fenster und übertragen Sie die Daten',
   'The documents have been sent to the printer \'#1\'.' => 'Die Dokumente sind zum Drucker \'#1\' geschickt',
diff --git a/locale/en/all b/locale/en/all
index 6b8c4f802..0865ca922 100644
--- a/locale/en/all
+++ b/locale/en/all
@@ -1010,6 +1010,7 @@ $self->{texts} = {
   'Display'                     => '',
   'Display file'                => '',
   'Display options'             => '',
+  'Displayable Name Preferences' => '',
   'Do not change the tax rate of taxkey 0.' => '',
   'Do not check for duplicates' => '',
   'Do not link to a project.'   => '',
@@ -1107,6 +1108,7 @@ $self->{texts} = {
   'E-Mail-Journal'              => '',
   'E-mail'                      => '',
   'E-mail address missing!'     => '',
+  'E.g. "<%customernumber%> <%name%>"' => '',
   'EAN'                         => '',
   'EAN-Code'                    => '',
   'EB-Wert'                     => '',
@@ -2121,6 +2123,7 @@ $self->{texts} = {
   'Open this Website'           => '',
   'OpenDocument/OASIS'          => '',
   'Openings'                    => '',
+  'Option'                      => '',
   'Optional comment'            => '',
   'Options'                     => '',
   'Or download the whole Installation Documentation as PDF (350kB) for off-line study (currently in German Language): ' => '',
@@ -3213,6 +3216,7 @@ $self->{texts} = {
   'The discount must be less than 100%.' => '',
   'The discount must not be negative.' => '',
   'The discounted amount will be shown in documents.' => '',
+  'The display of (mainly) picker results can be configured. To insert the value of one option use <%Name%>.' => '',
   'The document has been changed by another user. No mail was sent. Please reopen it in another window and copy the changes to the new window' => '',
   'The document has been changed by another user. Please reopen it in another window and copy the changes to the new window' => '',
   'The documents have been sent to the printer \'#1\'.' => '',